<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
<Title> Tango Device Server User's Guide </Title>
   <META NAME="GENERATOR" CONTENT="Mozilla/3.01Gold (X11; I; HP-UX B.10.20 9000/735) [Netscape]">
   <LINK HREF="doxygen.css" REL="stylesheet" TYPE="text/css">
</HEAD>
<BODY TEXT="#000000" BGCOLOR="#FFFFFF" LINK="#0000FF" VLINK="#FF0000" ALINK="#FF0000">

<P><!-------TITLE------></P>
<table width="100%" height="20%"><tr>
<td align=Center>
<FONT COLOR="#0000FF"><FONT SIZE=+3>E</FONT></FONT><FONT SIZE=+1>UROPEAN</FONT>
<FONT COLOR="#0000FF"><FONT SIZE=+3>S</FONT></FONT><FONT SIZE=+1>YNCHROTRON</FONT>
<FONT COLOR="#0000FF"><FONT SIZE=+3>R</FONT></FONT><FONT SIZE=+1>ADIATION</FONT>
<FONT COLOR="#0000FF"><FONT SIZE=+3>F</FONT></FONT><FONT SIZE=+1>ACILITY</FONT></H1>
<H5>INSTALLATION EUROPEENNE DE RAYONNEMENT SYNCHROTRON<BR>
</td><td>
<A href="http://www.esrf.fr">
<IMG SRC="http://www.esrf.fr/gifs/logo/80.gif" 
		ALT="ESRF Logo" ALIGN=RIGHT border="0"></A>
</td></tr></table>

</Body>
</Html>
<!-- Generated by Doxygen 1.2.13.1 -->
<center>
<a class="qindex" href="main.html">Main Page</a> &nbsp; <a class="qindex" href="namespaces.html">Namespace List</a> &nbsp; <a class="qindex" href="classes.html">Alphabetical List</a> &nbsp; <a class="qindex" href="annotated.html">Compound List</a> &nbsp; <a class="qindex" href="files.html">File List</a> &nbsp; <a class="qindex" href="namespacemembers.html">Namespace Members</a> &nbsp; <a class="qindex" href="functions.html">Compound Members</a> &nbsp; <a class="qindex" href="globals.html">File Members</a> &nbsp; </center>
<hr><h1>StarterUtil.h</h1><a href="StarterUtil_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre>00001 <font class="comment">//=============================================================================</font>
00002 <font class="comment">//</font>
00003 <font class="comment">// file :        StarterUtil.h</font>
00004 <font class="comment">//</font>
00005 <font class="comment">// description : Include for the StarterUtil class.</font>
00006 <font class="comment">//</font>
00007 <font class="comment">// project :    Starter for Tango Administration</font>
00008 <font class="comment">//</font>
00009 <font class="comment">// $Author: pascal_verdier $</font>
00010 <font class="comment">//</font>
00011 <font class="comment">// $Revision: 1.2 $</font>
00012 <font class="comment">//</font>
00013 <font class="comment">// copyleft :    European Synchrotron Radiation Facility</font>
00014 <font class="comment">//               BP 220, Grenoble 38043</font>
00015 <font class="comment">//               FRANCE</font>
00016 <font class="comment">//</font>
00017 <font class="comment">//=============================================================================</font>
00018 <font class="preprocessor">#ifndef _STARTER_UTIL_H</font>
00019 <font class="preprocessor"></font><font class="preprocessor">#define _STARTER_UTIL_H</font>
00020 <font class="preprocessor"></font>
00021 <font class="preprocessor">#include &lt;tango.h&gt;</font>
00022 
00033 <font class="keyword">namespace </font>Starter
00034 {
00035 
00036  <font class="comment">//     Add your own constants definitions here.</font>
00037  <font class="comment">//-----------------------------------------------</font>
00038 <font class="preprocessor">#ifndef WIN32</font>
00039 <font class="preprocessor"></font><font class="keyword">typedef</font> <font class="keywordtype">unsigned</font> <font class="keywordtype">char</font> <a class="code" href="namespaceStarter.html#a0">boolean</a>;
00040 <font class="preprocessor">#endif</font>
00041 <font class="preprocessor"></font>
<a name="l00042"></a><a class="code" href="structStarter_1_1ServerControled.html">00042</a> <font class="keyword">typedef</font> <font class="keyword">struct </font>{
<a name="l00043"></a><a class="code" href="structStarter_1_1ServerControled.html#m0">00043</a>         string  name;
<a name="l00044"></a><a class="code" href="structStarter_1_1ServerControled.html#m1">00044</a>         string  admin_name;
<a name="l00045"></a><a class="code" href="structStarter_1_1ServerControled.html#m2">00045</a>         <font class="keywordtype">bool</font>    controled;
<a name="l00046"></a><a class="code" href="structStarter_1_1ServerControled.html#m3">00046</a>         <font class="keywordtype">bool</font>    running;
<a name="l00047"></a><a class="code" href="structStarter_1_1ServerControled.html#m4">00047</a>         <font class="keywordtype">short</font>   startup_level;
<a name="l00048"></a><a class="code" href="structStarter_1_1ServerControled.html#m5">00048</a>         Tango::DeviceProxy      *dev;
00049 }
00050 ServerControled;
00051 
00052 <font class="comment">//      Definitions for separators</font>
00053 <font class="comment">//----------------------------------</font>
00054 <font class="preprocessor">#ifdef WIN32</font>
00055 <font class="preprocessor"></font><font class="preprocessor">#       define  slash   '\\'</font>
00056 <font class="preprocessor"></font><font class="preprocessor">#       define  TmpRoot "\\temp"</font>
00057 <font class="preprocessor"></font><font class="preprocessor">#else</font>
<a name="l00058"></a><a class="code" href="StarterUtil_8h.html#a0">00058</a> <font class="preprocessor"></font><font class="preprocessor">#       define  slash   '/'</font>
<a name="l00059"></a><a class="code" href="StarterUtil_8h.html#a1">00059</a> <font class="preprocessor"></font><font class="preprocessor">#       define  TmpRoot "/tmp"</font>
00060 <font class="preprocessor"></font><font class="preprocessor">#endif</font>
<a name="l00061"></a><a class="code" href="StarterUtil_8h.html#a2">00061</a> <font class="preprocessor"></font><font class="preprocessor">#define LogPath(s)              \</font>
00062 <font class="preprocessor">                s = TmpRoot;    \</font>
00063 <font class="preprocessor">                s += slash;             \</font>
00064 <font class="preprocessor">                s += "ds.log";</font>
00065 <font class="preprocessor"></font>
<a name="l00066"></a><a class="code" href="classStarter_1_1StarterUtil.html">00066</a> <font class="keyword">class </font>StarterUtil
00067 {
00068 <font class="keyword">public</font> :
00077 <a class="code" href="classStarter_1_1StarterUtil.html#z7_0">StarterUtil</a>(Tango::DeviceImpl *dev, string host_name);
00079 
00089 <font class="keywordtype">char</font> *<a class="code" href="classStarter_1_1StarterUtil.html#z8_0">get_server_name</a>(<font class="keywordtype">char</font> *argin);
00095 <font class="keywordtype">char</font> *<a class="code" href="classStarter_1_1StarterUtil.html#z8_1">get_instance_name</a>(<font class="keywordtype">char</font> *argin);
00103 <font class="keywordtype">char</font> *<a class="code" href="classStarter_1_1StarterUtil.html#z8_2">check_exe_file</a>(<font class="keywordtype">char</font> *servname, vector&lt;string&gt; v_path);
00109 string <a class="code" href="classStarter_1_1StarterUtil.html#z8_3">build_log_file_name</a>(<font class="keywordtype">char</font> *);
00114 <font class="keywordtype">char</font> *<a class="code" href="classStarter_1_1StarterUtil.html#z8_4">get_file_date</a>(<font class="keywordtype">char</font> *filename);
00118 <font class="keywordtype">char</font> *<a class="code" href="classStarter_1_1StarterUtil.html#z8_5">strtime</a>(time_t t);
00125 ServerControled *<a class="code" href="classStarter_1_1StarterUtil.html#z8_6">get_server_by_name</a>(string, vector&lt;ServerControled&gt;&amp;);
00132 vector&lt;string&gt;  <a class="code" href="classStarter_1_1StarterUtil.html#z8_7">get_host_ds_list</a>(Tango::DeviceProxy *);
00136 <font class="keywordtype">bool</font> <a class="code" href="classStarter_1_1StarterUtil.html#z8_8">is_notifyd_alive</a>(Tango::DeviceProxy *);
00137 
00138 <font class="preprocessor">#ifdef WIN32</font>
00139 <font class="preprocessor"></font>
00148 <font class="keywordtype">int</font> StarterUtil::strcasecmp(<font class="keyword">const</font> <font class="keywordtype">char</font> *s1, <font class="keyword">const</font> <font class="keywordtype">char</font> *s2);
00149 <font class="preprocessor">#endif</font>
00150 <font class="preprocessor"></font>
00151 <font class="keywordtype">void</font> <a class="code" href="classStarter_1_1StarterUtil.html#z8_9">start_timer</a>();
00152 <font class="keywordtype">int</font>     <a class="code" href="classStarter_1_1StarterUtil.html#z8_10">get_timer_value</a>();
00153 
00155 <font class="keyword">private</font>:
00156         <font class="keyword">static</font> <font class="keywordtype">int</font>      elapsed;
00157         string          hostname;
00158         string          notifyd_name;
00159 
00160 <font class="preprocessor">#ifndef WIN32</font>
00161 <font class="preprocessor"></font>        <font class="keyword">static</font> <font class="keyword">struct </font>timeval   before, after;
00162 <font class="preprocessor">#else</font>
00163 <font class="preprocessor"></font><font class="preprocessor">#endif </font><font class="comment">/* WIN32 */</font>
00164 };
00165 
00166 
00167 
00168 
00169 
00170 <font class="comment">//=========================================================</font>
00174 <font class="comment"></font><font class="comment">//=========================================================</font>
<a name="l00175"></a><a class="code" href="classStarter_1_1SharedData.html">00175</a> <font class="keyword">class </font>SharedData: <font class="keyword">public</font> Tango::TangoMonitor
00176 {
00177 <font class="keyword">private</font>:
00178         time_t  last_cmd_time;
00182         omni_thread                     *polling_id;
00183 
00184 <font class="keyword">public</font>:
00185         <a class="code" href="classStarter_1_1SharedData.html#a0">SharedData</a>();
00189 time_t <a class="code" href="classStarter_1_1SharedData.html#a1">get_timer</a>();
00193 <font class="keywordtype">void</font> <a class="code" href="classStarter_1_1SharedData.html#a2">set_timer</a>();
00194 };
00195 
00196 
00197 
00198 <font class="comment">//=========================================================</font>
00204 <font class="comment"></font><font class="comment">//=========================================================</font>
<a name="l00205"></a><a class="code" href="classStarter_1_1PollingState.html">00205</a> <font class="keyword">class </font>PollingState: <font class="keyword">public</font> omni_thread
00206 {
00207 <font class="keyword">private</font>:
00211         SharedData              *shared;
00215         Tango::DevBoolean       polling_on;
00219         Tango::DevLong          cmd_timeout;
00220 <font class="keyword">public</font>:
00229         <a class="code" href="classStarter_1_1PollingState.html#a0">PollingState</a>(SharedData *shared, <font class="keywordtype">long</font> timeout);
00230 
00236         <font class="comment">//virtual void run();</font>
00237 
00238         <font class="keywordtype">void</font> *<a class="code" href="classStarter_1_1PollingState.html#a1">run_undetached</a>(<font class="keywordtype">void</font> *);
<a name="l00239"></a><a class="code" href="classStarter_1_1PollingState.html#a2">00239</a>         <font class="keywordtype">void</font> <a class="code" href="classStarter_1_1PollingState.html#a2">start</a>() {start_undetached();}
00240 };
00241 
00242 }       <font class="comment">//      namespace</font>
00243 
00244 <font class="preprocessor">#endif  // _STARTER_UTIL_H</font>
</pre></div><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
<Title> Tango Device Server User's Guide </Title>
   <META NAME="GENERATOR" CONTENT="Mozilla/3.01Gold (X11; I; HP-UX B.10.20 9000/735) [Netscape]">
</HEAD>
<BODY TEXT="#000000" BGCOLOR="#FFFFFF" LINK="#0000FF" VLINK="#FF0000" ALINK="#FF0000">

<P><!-------TITLE------></P>

<Center>
<Br>
<HR WIDTH="100%"></H5>
<H3>(c) ESRF - Software Engineering Group </H33>
</Center>
</body>
</html>
